"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fold = exports.defaultIndex = exports.Functor = void 0;
var _registry = /*#__PURE__*/require("@traversable/registry");
var JsonSchema = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("./specification.js"));
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
const defaultIndex = exports.defaultIndex = {
  depth: 0,
  path: []
};
const Functor = exports.Functor = {
  map(f) {
    return x => {
      switch (true) {
        default:
          return _registry.fn.exhaustive(x);
        case JsonSchema.is.nullary(x):
          return x;
        case JsonSchema.is.enum(x):
          return x;
        case JsonSchema.is.const(x):
          return x;
        case JsonSchema.is.union(x):
          return {
            ...x,
            anyOf: _registry.fn.map(x.anyOf, f)
          };
        case JsonSchema.is.intersect(x):
          return {
            ...x,
            allOf: _registry.fn.map(x.allOf, f)
          };
        case JsonSchema.is.tuple(x):
          return {
            ...x,
            items: _registry.fn.map(x.items, f)
          };
        case JsonSchema.is.array(x):
          return {
            ...x,
            items: f(x.items)
          };
        case JsonSchema.is.object(x):
          return {
            ...x,
            properties: _registry.fn.map(x.properties, f)
          };
        case JsonSchema.is.record(x):
          return {
            ...x,
            additionalProperties: f(x.additionalProperties)
          };
      }
    };
  },
  mapWithIndex(f) {
    return (x, ix) => {
      const {
        depth,
        path
      } = ix;
      switch (true) {
        default:
          return _registry.fn.exhaustive(x);
        case JsonSchema.is.nullary(x):
          return x;
        case JsonSchema.is.enum(x):
          return x;
        case JsonSchema.is.const(x):
          return x;
        case JsonSchema.is.tuple(x):
          return {
            ...x,
            items: _registry.fn.map(x.items, (v, i) => f(v, {
              depth: depth + 1,
              path: [...path, i]
            }))
          };
        case JsonSchema.is.array(x):
          return {
            ...x,
            items: f(x.items, {
              depth: depth + 1,
              path
            })
          };
        case JsonSchema.is.union(x):
          return {
            ...x,
            anyOf: _registry.fn.map(x.anyOf, (v, i) => f(v, {
              depth: depth + 1,
              path: [...path, i]
            }))
          };
        case JsonSchema.is.intersect(x):
          return {
            ...x,
            allOf: _registry.fn.map(x.allOf, (v, i) => f(v, {
              depth: depth + 1,
              path: [...path, i]
            }))
          };
        case JsonSchema.is.object(x):
          return {
            ...x,
            properties: _registry.fn.map(x.properties, (v, k) => f(v, {
              depth: depth + 1,
              path: [...path, k]
            }))
          };
        case JsonSchema.is.record(x):
          return {
            ...x,
            additionalProperties: f(x.additionalProperties, {
              depth: depth + 1,
              path
            })
          };
      }
    };
  }
};
const fold = exports.fold = /*#__PURE__*/_registry.fn.cataIx(Functor, defaultIndex);
//# sourceMappingURL=functor.js.map