import { fc } from '@fast-check/vitest';
import type * as Spec from '@traversable/schema-to-json-schema/specification';
import type { JsonSchema } from '@traversable/schema-to-json-schema';
export declare function withPartialKeysOf<T extends Record<never, unknown>>(model: fc.Arbitrary<T>, keyCount: number): fc.Arbitrary<[T, string[]]>;
export declare const defaults: {
    object: {
        keyCount: number;
    };
};
export declare function tuple(cont: fc.LetrecTypedTie<Builder>): fc.Arbitrary<Builder['tuple']>;
export declare function object(cont: fc.LetrecTypedTie<Builder>, constraints?: Builder.Constraints['object']): fc.Arbitrary<Builder['object']>;
export declare function array(cont: fc.LetrecTypedTie<Builder>): fc.Arbitrary<Builder['array']>;
export declare function record(cont: fc.LetrecTypedTie<Builder>): fc.Arbitrary<Builder['record']>;
export declare function union(cont: fc.LetrecTypedTie<Builder>): fc.Arbitrary<Builder['union']>;
export declare function intersect(cont: fc.LetrecTypedTie<Builder>): fc.Arbitrary<Builder['intersect']>;
export type Arbitraries<K extends keyof BuilderNodes = keyof BuilderNodes> = {
    [P in K]: fc.Arbitrary<BuilderNodes[P]>;
};
export type ObjectConstraints = Omit<fc.DictionaryConstraints, 'minKeys' | 'maxKeys'> & {
    keyCount?: number;
};
export interface BuilderNodes {
    boolean: Spec.boolean;
    integer: Spec.integer;
    number: Spec.number;
    string: Spec.string;
    array: Spec.array<JsonSchema>;
    record: Spec.record<JsonSchema>;
    tuple: Spec.tuple<JsonSchema[]>;
    union: Spec.union<JsonSchema[]>;
    intersect: Spec.intersect<JsonSchema[]>;
    object: Spec.object<{
        [x: string]: JsonSchema;
    }>;
}
export interface Builder extends BuilderNodes {
    tree: BuilderNodes[keyof BuilderNodes];
}
export declare namespace Builder {
    type Constraints = {
        object?: ObjectConstraints;
    };
}
export declare function Builder(constraints?: Builder.Constraints): (cont: fc.LetrecTypedTie<Builder>) => {
    [K in keyof Builder]: fc.Arbitrary<Builder[K]>;
};
export declare function Builder<T extends Partial<Arbitraries>>(constraints: Builder.Constraints, arbitraries: T): (cont: fc.LetrecTypedTie<Builder>) => {
    [K in keyof Builder]: fc.Arbitrary<K extends keyof T ? T[K] : Builder[K]>;
};
export declare const any: (constraints?: Builder.Constraints) => fc.Arbitrary<JsonSchema>;
//# sourceMappingURL=arbitrary.d.ts.map