import type { HKT } from '@traversable/registry';
import { t } from '@traversable/schema';
export declare const RAW: {
    any: {
        type: "object";
        properties: {};
        nullable: true;
    };
    null: {
        type: "null";
        enum: [null];
    };
    boolean: {
        type: "boolean";
    };
    integer: {
        type: "integer";
    };
    number: {
        type: "number";
    };
    string: {
        type: "string";
    };
};
export { JsonSchema_any as any };
interface JsonSchema_any {
    type: 'object';
    properties: {};
    nullable: true;
}
declare const JsonSchema_any: t.eq<{
    type: "object";
    properties: {};
    nullable: true;
}>;
export { JsonSchema_null as null };
interface JsonSchema_null {
    type: 'null';
    enum: [null];
}
declare const JsonSchema_null: t.object<{
    type: t.eq<"null">;
}>;
export { JsonSchema_boolean as boolean };
interface JsonSchema_boolean {
    type: 'boolean';
}
declare const JsonSchema_boolean: t.object<{
    type: t.eq<"boolean">;
}>;
export type NumericBounds = t.typeof<typeof NumericBounds>;
export declare const NumericBounds: t.object<{
    minimum: t.optional<t.number>;
    maximum: t.optional<t.number>;
    exclusiveMinimum: t.optional<t.union<[t.boolean, t.number]>>;
    exclusiveMaximum: t.optional<t.union<[t.boolean, t.number]>>;
}>;
export type SizeBounds = t.typeof<typeof SizeBounds>;
export declare const SizeBounds: t.object<{
    minLength: t.optional<t.number>;
    maxLength: t.optional<t.number>;
}>;
export { JsonSchema_integer as integer, JsonSchema_integer as IntegerSchema };
interface JsonSchema_integer extends NumericBounds {
    type: 'integer';
}
declare const JsonSchema_integer: t.object<{
    minimum: t.optional<t.number>;
    maximum: t.optional<t.number>;
    exclusiveMinimum: t.optional<t.union<[t.boolean, t.number]>>;
    exclusiveMaximum: t.optional<t.union<[t.boolean, t.number]>>;
    type: t.eq<"integer">;
}>;
export { JsonSchema_number as number, JsonSchema_number as NumberSchema };
interface JsonSchema_number extends NumericBounds {
    type: 'number';
}
declare const JsonSchema_number: t.object<{
    minimum: t.optional<t.number>;
    maximum: t.optional<t.number>;
    exclusiveMinimum: t.optional<t.union<[t.boolean, t.number]>>;
    exclusiveMaximum: t.optional<t.union<[t.boolean, t.number]>>;
    type: t.eq<"number">;
}>;
export { JsonSchema_string as string, JsonSchema_string as StringSchema };
interface JsonSchema_string extends SizeBounds {
    type: 'string';
}
declare const JsonSchema_string: t.object<{
    minLength: t.optional<t.number>;
    maxLength: t.optional<t.number>;
    type: t.eq<"string">;
}>;
export { JsonSchema_optional as optional };
declare const JsonSchema_optional: t.object<{
    nullable: t.eq<true>;
}>;
export { JsonSchema_const as const };
interface JsonSchema_const<T = unknown> {
    const: T;
}
declare const JsonSchema_const: t.object<{
    const: t.unknown;
}>;
export { JsonSchema_enum as enum };
interface JsonSchema_enum<T = unknown> {
    enum: readonly T[];
}
declare const JsonSchema_enum: t.of<JsonSchema_enum<unknown>>;
export { JsonSchema_array as array };
interface JsonSchema_array<T = unknown> {
    type: 'array';
    items: T;
}
declare const JsonSchema_array: t.object<{
    type: t.eq<"array">;
    items: t.unknown;
}>;
export { JsonSchema_record as record };
interface JsonSchema_record<T = unknown> {
    type: 'object';
    additionalProperties: T;
}
declare const JsonSchema_record: <T>(u: unknown) => u is JsonSchema_record<T>;
export { JsonSchema_union as union };
interface JsonSchema_union<T = unknown> {
    anyOf: T;
}
declare const JsonSchema_union: t.of<JsonSchema_union<unknown>>;
export { JsonSchema_intersect as intersect };
interface JsonSchema_intersect<T = unknown> {
    allOf: T;
}
declare const JsonSchema_intersect: t.of<JsonSchema_intersect<unknown>>;
export { JsonSchema_object as object };
interface JsonSchema_object<T> {
    type: 'object';
    required: string[];
    properties: T;
}
declare const JsonSchema_object: t.object<{
    type: t.eq<"object">;
    required: t.array<t.string>;
    properties: t.unknown;
}>;
export { JsonSchema_tuple as tuple };
interface JsonSchema_tuple<T> {
    type: 'array';
    items: T;
    minItems: number;
    maxItems: number;
    additionalItems: false;
}
declare const JsonSchema_tuple: t.object<{
    type: t.eq<"array">;
    items: t.unknown;
    minItems: t.number;
    maxItems: t.number;
    additionalItems: t.eq<false>;
}>;
export declare const is: {
    any: t.eq<{
        type: "object";
        properties: {};
        nullable: true;
    }>;
    null: t.object<{
        type: t.eq<"null">;
    }>;
    boolean: t.object<{
        type: t.eq<"boolean">;
    }>;
    integer: t.object<{
        minimum: t.optional<t.number>;
        maximum: t.optional<t.number>;
        exclusiveMinimum: t.optional<t.union<[t.boolean, t.number]>>;
        exclusiveMaximum: t.optional<t.union<[t.boolean, t.number]>>;
        type: t.eq<"integer">;
    }>;
    number: t.object<{
        minimum: t.optional<t.number>;
        maximum: t.optional<t.number>;
        exclusiveMinimum: t.optional<t.union<[t.boolean, t.number]>>;
        exclusiveMaximum: t.optional<t.union<[t.boolean, t.number]>>;
        type: t.eq<"number">;
    }>;
    string: t.object<{
        minLength: t.optional<t.number>;
        maxLength: t.optional<t.number>;
        type: t.eq<"string">;
    }>;
    enum: t.of<JsonSchema_enum<unknown>>;
    const: t.object<{
        const: t.unknown;
    }>;
    optional: t.object<{
        nullable: t.eq<true>;
    }>;
    array: t.object<{
        type: t.eq<"array">;
        items: t.unknown;
    }>;
    record: <T>(u: unknown) => u is JsonSchema_record<T>;
    union: t.of<JsonSchema_union<unknown>>;
    intersect: t.of<JsonSchema_intersect<unknown>>;
    tuple: t.object<{
        type: t.eq<"array">;
        items: t.unknown;
        minItems: t.number;
        maxItems: t.number;
        additionalItems: t.eq<false>;
    }>;
    object: t.object<{
        type: t.eq<"object">;
        required: t.array<t.string>;
        properties: t.unknown;
    }>;
    nullary: t.union<[t.eq<{
        type: "object";
        properties: {};
        nullable: true;
    }>, t.object<{
        type: t.eq<"null">;
    }>, t.object<{
        type: t.eq<"boolean">;
    }>, t.object<{
        minimum: t.optional<t.number>;
        maximum: t.optional<t.number>;
        exclusiveMinimum: t.optional<t.union<[t.boolean, t.number]>>;
        exclusiveMaximum: t.optional<t.union<[t.boolean, t.number]>>;
        type: t.eq<"integer">;
    }>, t.object<{
        minimum: t.optional<t.number>;
        maximum: t.optional<t.number>;
        exclusiveMinimum: t.optional<t.union<[t.boolean, t.number]>>;
        exclusiveMaximum: t.optional<t.union<[t.boolean, t.number]>>;
        type: t.eq<"number">;
    }>, t.object<{
        minLength: t.optional<t.number>;
        maxLength: t.optional<t.number>;
        type: t.eq<"string">;
    }>]>;
    unary: t.union<[t.object<{
        type: t.eq<"array">;
        items: t.unknown;
    }>, <T>(u: unknown) => u is JsonSchema_record<T>, t.of<JsonSchema_union<unknown>>, t.of<JsonSchema_intersect<unknown>>, t.object<{
        type: t.eq<"array">;
        items: t.unknown;
        minItems: t.number;
        maxItems: t.number;
        additionalItems: t.eq<false>;
    }>, t.object<{
        type: t.eq<"object">;
        required: t.array<t.string>;
        properties: t.unknown;
    }>]>;
    special: t.union<[t.of<JsonSchema_enum<unknown>>, t.object<{
        const: t.unknown;
    }>]>;
};
export type Nullary = JsonSchema_any | JsonSchema_null | JsonSchema_boolean | JsonSchema_integer | JsonSchema_number | JsonSchema_string;
export type JsonSchema = Nullary | JsonSchema_const | JsonSchema_enum | JsonSchema_array<JsonSchema> | JsonSchema_record<JsonSchema> | JsonSchema_union<readonly JsonSchema[]> | JsonSchema_intersect<readonly JsonSchema[]> | JsonSchema_tuple<readonly JsonSchema[]> | JsonSchema_object<{
    [x: string]: JsonSchema;
}>;
export type Unary<T> = Nullary | JsonSchema_const | JsonSchema_enum | JsonSchema_array<T> | JsonSchema_record<T> | JsonSchema_union<readonly T[]> | JsonSchema_intersect<readonly T[]> | JsonSchema_tuple<readonly T[]> | JsonSchema_object<{
    [x: string]: T;
}>;
export interface Free extends HKT {
    [-1]: Unary<this[0]>;
}
//# sourceMappingURL=specification.d.ts.map